# Compilare

Cel mai popular compilator de C/C++ este **gcc**. Să presupunem că avem un
fișier sursă numit `hello.c`. Compilarea standard a acestui fișier se face
folosind `gcc hello.c`. 

Ca rezultat se obține un fișier `a.out` care se poate executa. Dacă însă
compilăm folosind `gcc hello.c -o hello` se va obține fișierul executabil
`hello`.

Pentru un cod scris in C++, `.cpp`, vom folosi `g++`.

- Opțiunea **-g** va permite obținerea unui executabil care va conține
informații de debug. Această opțiune este utilă în combinație cu un program de
debugging cum ar fi gdb.


---
**NOTĂ**

Pentru a detecta accesările invalde la memorie, vom compila programul nostru cu
address sanitization (ASAN) folosind următorul flag: `-fsanitize=address`. Mai
mult, pentru a evita undefined behavior vom folosi `-fsanitize=undefined`.
Aceste opțiuni sunt utile pentru a ne asigura că programul scris de noi nu are
bug-uri ascunse. **Recomandăm rularea codului cu aceste opțiuni înainte de a face
submisii la teme.**

---
