# Rezumate de mesaje

Rezumatul (hash) unui mesaj este un șir de biți de lungime fixă, generat
cu ajutorul unei funcții de dispersie neinversabile aplicată mesajului.
Funcția de dispersie H trebuie să aibă următoarele proprietăți:

  - Dându-se un mesaj M, este ușor de calculat H(M)\
  - Dându-se un rezumat H(M), este greu de calculat M\
  - Dându-se un mesaj M, este greu de găsit M0 astfel încât H(M) = H(M0)\
  - O schimbare mică în mesaj (chiar și de 1 bit) produce un rezumat foarte diferit

Rezumatele pot fi utilizate pentru a verifică rapid transmisia corectă a
unui mesaj (rezumatul este transmis împreună cu mesajul și destinatarul
verifică dacă rezumatul primit coincide cu rezumatul recalculat de către
el) și pentru realizarea semnăturilor digitale.

Exemple de algoritmi pentru calculul de rezumate:
[MD5](https://en.wikipedia.org/wiki/MD5),
[SHA-1](https://en.wikipedia.org/wiki/SHA-1),
[SHA-2](https://en.wikipedia.org/wiki/SHA-2),
[SHA-3](https://en.wikipedia.org/wiki/SHA-3)
