## socket()


``` C
#include <sys/types.h>
#include <sys/socket.h>
   
/* creare socket in C */
/* int socket(int domain, int type, int protocol); */
   
/* pentru UDP, folosim un socket de tip SOCK_DGRAM */
int sockid = socket(PF_INET, SOCK_DGRAM, 0);
   
if (sockid == -1) {
  /* trateaza eroare */
}
```

Explicatii:

* `sockid` - file descriptor pentru socket. În caz de eroare se întoarce -1 si se seteaza variabila `errno`.
* `domain` - reprezintă familia de protocoale pe care urmează să le utilizam în transferul informației. Vom folosi valorile *PF_INET* pentru IPv4 sau *PF_INET6* pentru IPv6.  
* `type` - reprezinta tipul socketului. Valori uzuale:
  * **SOCK_STREAM** - Indicata stabilirea unei comunicatii bazata pe construirea unei conexiuni intre sursa si destinatie.   Comunicatia este FIFO, fiabila si sigura, o vom folosi la laboratorul urmator cu TCP.  
  * **SOCK_DGRAM** - Ofera un flux de date bidirectional, care nu promite sa fie sigur, in secventa sau neduplicat. Un proces care receptioneaza mesaje pe un socket datagrama, poate gasi mesaje duplicate si posibil intr-o ordine diferita fata de cea in care au fost trimise.   
* protocol - specifica protocolul de transport utilizat. **Vom seta pe valoarea 0**, pentru a se alege protocolul corect in functie de *type*.  

Pentru a afla mai multe informatii, putem accesa urmatorul capitol[5.2
socket()—Get the File
Descriptor\!](https://beej.us/guide/bgnet/html/#socket)
